' ͻ
'  Uploaded by:                                        
'    Scott Tucker                                      
'    Creative Software Alliance                        
'    16 Lakeville Hwy.                                 
'    Petaluma, CA 94954                                
'    (707)778-1591                                     
'                                                      
'  On: 02/28/1994                                      
'                                                      
'   You, of course, may use this code in any manner    
'   you see fit. If it kills your computer or does     
'   any damage at all, I am not to blame. Sorry about  
'   the caveat.                                        
'                                                      
' ͼ
'  

Cls

ReDim F$(0)                      ' create a dynamic array to hold file names

' Call the procedure
 Call GetFiles("*.*", 3, 0, F$())      ' all files and directories
'Call GetFiles("*.*", 1, 0, F$())      ' all files only
'Call GetFiles("*.*", 2, 0, F$())      ' directories only
'Call GetFiles("*.bas", 1, 0, F$())    ' *.bas files only. You get the idea.

C% = UBound(F$)                       ' How many did we get?

For K%=1 to C%                        ' Show 'em to me
 Print F$(K%),
next

End
'===========
' ͻ
' ͹       This is the Procedure.                  ͹
' ͼ
Sub GetFiles(ByVal FileSpec$, ByVal FileType%, ByVal SortList%, _
             FileNameArray$())
  ' FileSpec$ = name of file or wildcard convention
  ' FileType%   1 = Regular files
  '             2 = Subdirectories
  '             3 = All files and directories
  ' SortList%   Boolean  True = sort array; False = no sort
  ' FileNameArray$() must be Dim'ed as a Dynamic array before being passed
  '  into this proc. It will be ReDim'ed to hold the exact number of
  '  files to be returned.

  ' Assumes no more than 1000 files will be returned.
  ' To get subdir names, pass the "*.*" filespec with a type 2 file type.
  '=================================================
  Local Maxfiles%, Temp$(), C%, X$, K%

  MaxFiles% = 1000                  ' increase if necessary.
  ReDim Temp$(1 to MaxFiles%)       ' temp file holder
  C%=0                              ' file counter

  If FileSpec$ = "" then Exit Sub   ' why bother?
  If FileType% < 1 or FileType% > 3 then FileType% = 1  ' just in case

  X$ = Dir$(FileSpec$, 16)          ' Get a first look at the files

  Select Case FileType%
    Case 1               ' Regular Files
      If X$ <> "" and (Attrib(X$) and 16) < 16 then   ' find files
        Incr C%
        Temp$(C%) = X$
      End IF

      While X$ <> "" and C% <= MaxFiles%
        X$ = Dir$
        If X$ <> "" and (Attrib(X$) and 16) < 16 then
          Incr C%
          Temp$(C%) = X$
        End IF
      Wend

    Case 2               ' Subdirectories Only
      If X$ <> "" and (Attrib(X$) and 16) = 16 then   ' find files
        Incr C%
        Temp$(C%) = X$
      End IF

      While X$ <> "" and C% <= MaxFiles%
        X$ = Dir$
        If X$ <> "" and (Attrib(X$) and 16) = 16 then
          Incr C%
          Temp$(C%) = X$
        End IF
      Wend

    Case 3               ' Get all of 'em
      If X$ <> "" then   ' find files
        Incr C%
        Temp$(C%) = X$
      End IF

      While X$ <> "" and C% <= MaxFiles%
        X$ = Dir$
        If X$ <> "" then
          Incr C%
          Temp$(C%) = X$
        End IF
      Wend

    Case Else
  End Select

  ReDim FileNameArray$(C%)              ' Redim array to hold files

  For K%=1 to C%                        ' load array
    FileNameArray$(K%) = Temp$(K%)
  Next

  If SortList% then Array Sort FileNameArray$()  ' sort if required
  Erase Temp$
End Sub
' ͻ
' ͼ
